#!/usr/bin/php4 -q
<?

/*
RTGUJE by Elita (rozanski@sergiusz.com)
based on JPT written by: Jan Starzak <jstar@starzaki.eu.org>, Piotr Filipiak
*/

global $USRARRAY;
require("class.jabber.php");

$HOME = getenv("HOME");
$JABBER = new Jabber;

/* edycja! */

$JABBER->server         = "host.pl"; // server
$JABBER->port           = 5222;
$JABBER->username       = "nick";   // nick
$JABBER->password       = "Pa55w0rD";
$JABBER->resource       = "rtg";
$JABBER->iq_version_name = "RTG on Class.Jabber.PHP";
$JABBER->iq_version_os = "Linux";
$JABBER->iq_version_version = "wczesna alfa 0.0.1";

/* */

echo "RTGUJE - RTG mikro jabber engine\n";
echo "Homedir: ".$HOME."\n";
echo "Connect: ";
$JABBER->Connect() or die("no connect :(\n");
echo "ok\nAuth: ";
$JABBER->SendAuth() or die("no auth :(\n");
echo "ok\n";

$JABBER->SendPresence(NULL, NULL, "online");

$JABBER->RosterUpdate();
$roster = $JABBER->roster;

for ($i = 0; $i < count($roster); $i++) {
    $USRARRAY[$i]["id"] = $JABBER->StripJID($roster[$i]["jid"]);
    $USRARRAY[$i]["name"] = $roster[$i]["name"];
    $USRARRAY[$i]["show"] = "offline";
    $USRARRAY[$i]["group"] = $roster[$i]["group"];
    }	

$filename=sprintf ("%s/.gg/pipewapj",$HOME);

posix_mkfifo($filename,0700);
$pipe=fopen ($filename,"r",NONBLOCK) or die ("Pipe problem :(\n");

// echo 2;

$li="";

while(1) {
    $filename=sprintf ("%s/.gg/wap-roster",$HOME);
    if(($file=fopen ($filename,"w"))) {
	for ($i = 0; $i < count($USRARRAY); $i++) {
	    $line=sprintf("%s;%s;%s;%s;%s\n",
		$USRARRAY[$i]["id"],
		$USRARRAY[$i]["name"],
		$USRARRAY[$i]["status"],
		$USRARRAY[$i]["group"],
		$USRARRAY[$i]["show"]
		);
	    fputs($file,$line);
	    }
	fclose($file);
	}
    for ($j = 0;  $j < 15 ; $j++) {
	$linia=fgets($pipe,4096);
	if($linia) {
	    for ($k=0 ; $k<strlen($linia); $k++) {
		if($linia[$k]!="\n")
		    $li.=$linia[$k];
		else {
		    $cmd=substr($li,0,strpos($li,' '));
		    $res=substr($li,strpos($li,' ')+1,4096);
		    $to=substr($res,0,strpos($res,' '));
		    $body=substr($res,strpos($res,' ')+1,4096);
		    
		    printf("[%s][%s] %s\n",$cmd,$to,$body);
		    if($cmd=="chat") {
			$JABBER->SendMessage($to, "chat", NULL, array("body" => $body));
			}
		    
		    $li="";
		    }
		}
	    }
	$JABBER->CruiseControl(2);
	}
    }

$JABBER->Disconnect();

function Handler_message_normal($message) {
    global $JABBER;
    global $HOME;

    $from = $JABBER->StripJID($JABBER->GetInfoFromMessageFrom($message));
    $body = $JABBER->GetInfoFromMessageBody($message);
    echo "[".$from."]".$body."\n";
    $filename=sprintf ("%s/.gg/wap%s_%s",$HOME,date("H:is"),$from);
    if(($file=fopen ($filename,"w"))) {
	$line=sprintf("%s;%s\n",$from,$body);
	fputs($file,$line);
	fclose($file);
	}
    }

function Handler_message_chat($message) {
    global $JABBER;
    global $HOME;

    $from = $JABBER->StripJID($JABBER->GetInfoFromMessageFrom($message));
    $body = $JABBER->GetInfoFromMessageBody($message);
    echo "[".$from."]".$body."\n";
    $filename=sprintf ("%s/.gg/wap%s_%s",$HOME,date("H:is"),$from);
    if(($file=fopen ($filename,"w"))) {
	$line=sprintf("%s;%s\n",$from,$body);
	fputs($file,$line);
	fclose($file);
	}
    }

function update_status($JABBER, $presence, $when)
  {
    global $USRARRAY;
    $from = $JABBER->StripJID($JABBER->GetInfoFromPresenceFrom($presence));
    $show = $JABBER->GetInfoFromPresenceShow($presence);
    $status = $JABBER->GetInfoFromPresenceStatus($presence);
    $type = $JABBER->GetInfoFromPresenceType($presence);
    for ($i = 0; $i <= count($USRARRAY); $i++) {
      if ($USRARRAY[$i]["id"] == $from) {
        if ($show == "") {
          $USRARRAY[$i]["show"] = "online";
        } else {
          $USRARRAY[$i]["show"] = $show;
        }
        $USRARRAY[$i]["status"] = $status;
        echo "[".$from."]".$USRARRAY[$i]["show"]." ".$status."\n";
      }
    }
  }
  
  function Handler_presence_available($presence)
  {
    global $JABBER;
    update_status($JABBER, $presence, "online");
  }
  
  function Handler_presence_subscribe($presence)
  {
    global $JABBER;
    update_status($JABBER, $presence, "online");
  }
  
  function Handler_presence_unavailable($presence)
  {
    global $JABBER;
    update_status($JABBER, $presence, "offline");
  }
  
  function Handler_presence_unsubscribe($presence)
  {
    global $JABBER;
    update_status($JABBER, $presence, "offline");
  }
  
  function Handler_presence_unsubscribed($presence)
  {
    global $JABBER;
    update_status($JABBER, $presence, "offline");
  }
  
  function Handler_presence_probe($presence)
  {
    global $JABBER;
    update_status($JABBER, $presence, "offline");
  }

?>
